source_options

Options for creating a source node for a sender or receiver. More...

`#include <source_options.hpp>`

## Public Member Functions

| source_options ()
| Create an empty set of options.
| source_options (const source_options &)
| Copy options.
source_options & | operator= (const source_options &)
| Copy options.
source_options & | address (const std::string &)
| Set the address for the source. More...
source_options & | dynamic (bool)
| Request that a node be dynamically created by the remote peer. More...
source_options & | distribution_mode (enum source::distribution_mode)
| Control whether messages are browsed or consumed. More...
source_options & | durability_mode (enum source::durability_mode)
| Control the persistence of the source node. More...
source_options & | timeout (duration)
| The expiry period after which the source is discarded. More...
source_options & | expiry_policy (enum source::expiry_policy)
| Control when the clock for expiration begins. More...
source_options & | filters (const source::filter_map &)
| Unsettled API - Specify a filter mechanism on the source that restricts message flow to a subset of the available messages.
source_options & | capabilities (const std::vector< symbol > &)
| Extension capabilities that are supported/requested.

## Detailed Description

Options for creating a source node for a sender or receiver.

Options can be "chained". For more information see proton::connection_options.

Normal value semantics: copy or assign creates a separate copy of the options.

Examples
  broker.cpp, client.cpp, server_direct.cpp, and service_bus.cpp.

## Member Function Documentation

## address()

source_options& address | ( | const std::string & |  | ) |

Set the address for the source.

It is unset by default. The address is ignored if dynamic() is true.

## dynamic()

source_options& dynamic | ( | bool |  | ) |

Request that a node be dynamically created by the remote peer.

The default is false. Any specified source address() is ignored.

## distribution_mode()

source_options& distribution_mode | ( | enum source::distribution_mode |  | ) |

Control whether messages are browsed or consumed.

The default is source::MOVE, meaning consumed.

## durability_mode()

source_options& durability_mode | ( | enum source::durability_mode |  | ) |

Control the persistence of the source node.

The default is source::NONDURABLE, meaning non-persistent.

## timeout()

source_options& timeout | ( | duration |  | ) |

The expiry period after which the source is discarded.

The default is no timeout.

## expiry_policy()

source_options& expiry_policy | ( | enum source::expiry_policy |  | ) |

Control when the clock for expiration begins.

The default is source::LINK_CLOSE.

The documentation for this class was generated from the following file:

- proton/source_options.hpp